Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/ChernoffIntervalEstimationPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/ChernoffIntervalEstimationPolicy.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/ChernoffIntervalEstimationPolicy.cs	(revision 11732)
@@ -10,29 +10,31 @@
 International Conference, CP 2006, Nantes, France, September 25-29, 2006. pp 560-574 */
 
-  public class ChernoffIntervalEstimationPolicy : BanditPolicy {
-    private readonly int[] tries;
-    private readonly double[] sumReward;
-    private int totalTries = 0;
+  public class ChernoffIntervalEstimationPolicy : IPolicy {
     private readonly double delta;
 
-    public ChernoffIntervalEstimationPolicy(int numActions, double delta = 0.01)
-      : base(numActions) {
+    public ChernoffIntervalEstimationPolicy(double delta = 0.01) {
       this.delta = delta;
-      this.tries = new int[numActions];
-      this.sumReward = new double[numActions];
     }
-
-    public override int SelectAction() {
+    public int SelectAction(Random random, IEnumerable<IPolicyActionInfo> actionInfos) {
+      Debug.Assert(actionInfos.Any());
+      // select best
+      var myActionInfos = actionInfos.OfType<DefaultPolicyActionInfo>().ToArray(); // TODO: performance
+      int k = myActionInfos.Length;
+      int totalTries = myActionInfos.Where(a => !a.Disabled).Sum(a => a.Tries);
       int bestAction = -1;
       double bestQ = double.NegativeInfinity;
-      double k = Actions.Count();
-      Debug.Assert(k > 0);
-      foreach (var a in Actions) {
-        if (tries[a] == 0) return a;
+      for (int a = 0; a < myActionInfos.Length; a++) {
+        if (myActionInfos[a].Disabled) continue;
+        if (myActionInfos[a].Tries == 0) return a;
+
+        var sumReward = myActionInfos[a].SumReward;
+        var tries = myActionInfos[a].Tries;
+
+        var avgReward = sumReward / tries;
+
         // page 5 of "A simple distribution-free appraoch to the max k-armed bandit problem"
         // var alpha = Math.Log(2 * totalTries * k / delta);
         double alpha = Math.Log(2) + Math.Log(totalTries) + Math.Log(k) - Math.Log(delta); // total tries is max tries in the original paper
-        double mu = sumReward[a] / tries[a];
-        var q = mu + (alpha + Math.Sqrt(2 * tries[a] * mu * alpha + alpha * alpha)) / tries[a];
+        var q = avgReward + (alpha + Math.Sqrt(2 * tries * avgReward * alpha + alpha * alpha)) / tries;
         if (q > bestQ) {
           bestQ = q;
@@ -40,37 +42,12 @@
         }
       }
+      Debug.Assert(bestAction >= 0);
       return bestAction;
     }
-    public override void UpdateReward(int action, double reward) {
-      Debug.Assert(Actions.Contains(action));
-      totalTries++;
-      tries[action]++;
-      sumReward[action] += reward;
+
+    public IPolicyActionInfo CreateActionInfo() {
+      return new DefaultPolicyActionInfo();
     }
 
-    public override void DisableAction(int action) {
-      base.DisableAction(action);
-      totalTries -= tries[action];
-      tries[action] = -1;
-      sumReward[action] = 0;
-    }
-
-    public override void Reset() {
-      base.Reset();
-      totalTries = 0;
-      Array.Clear(tries, 0, tries.Length);
-      Array.Clear(sumReward, 0, sumReward.Length);
-    }
-
-    public override void PrintStats() {
-      for (int i = 0; i < sumReward.Length; i++) {
-        if (tries[i] >= 0) {
-          Console.Write("{0,5:F2}", sumReward[i] / tries[i]);
-        } else {
-          Console.Write("{0,5}", "");
-        }
-      }
-      Console.WriteLine();
-    }
     public override string ToString() {
       return string.Format("ChernoffIntervalEstimationPolicy({0:F2})", delta);
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/DefaultPolicyActionInfo.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/DefaultPolicyActionInfo.cs	(revision 11732)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/DefaultPolicyActionInfo.cs	(revision 11732)
@@ -0,0 +1,40 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  // stores information that is relevant for most of the policies
+  public class DefaultPolicyActionInfo : IPolicyActionInfo {
+    public bool Disabled { get { return Tries == -1; } }
+    public double SumReward { get; private set; }
+    public double MaxReward { get; private set; }
+    public int Tries { get; private set; }
+
+    public DefaultPolicyActionInfo() {
+      MaxReward = double.NegativeInfinity;
+    }
+
+    public void UpdateReward(double reward) {
+      Debug.Assert(!Disabled);
+
+      Tries++;
+      SumReward += reward;
+      MaxReward = Math.Max(MaxReward, reward);
+    }
+    public void Disable() {
+      this.Tries = -1;
+      this.SumReward = 0.0;
+    }
+    public void Reset() {
+      SumReward = 0.0;
+      Tries = 0;
+      MaxReward = 0.0;
+    }
+    public void PrintStats() {
+      Console.WriteLine("avg reward {0,5:F2} disabled {1}", SumReward / Tries, Disabled);
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/EmptyPolicyActionInfo.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/EmptyPolicyActionInfo.cs	(revision 11732)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/EmptyPolicyActionInfo.cs	(revision 11732)
@@ -0,0 +1,18 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  public class EmptyPolicyActionInfo : IPolicyActionInfo {
+    public bool Disabled { get; private set; }
+    public void UpdateReward(double reward) {
+      Debug.Assert(!Disabled);
+    }
+    public void Disable() { this.Disabled = true; }
+    public void Reset() { this.Disabled = false; }
+    public void PrintStats() { Console.WriteLine("disabled {0}", Disabled); }
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/EpsGreedyPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/EpsGreedyPolicy.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/EpsGreedyPolicy.cs	(revision 11732)
@@ -7,32 +7,33 @@
 
 namespace HeuristicLab.Algorithms.Bandits {
-  public class EpsGreedyPolicy : BanditPolicy {
-    private readonly Random random;
+  public class EpsGreedyPolicy : IPolicy {
     private readonly double eps;
-    private readonly int[] tries;
-    private readonly double[] sumReward;
     private readonly RandomPolicy randomPolicy;
 
-    public EpsGreedyPolicy(Random random, int numActions, double eps)
-      : base(numActions) {
-      this.random = random;
+    public EpsGreedyPolicy(double eps) {
       this.eps = eps;
-      this.randomPolicy = new RandomPolicy(random, numActions);
-      this.tries = new int[numActions];
-      this.sumReward = new double[numActions];
+      this.randomPolicy = new RandomPolicy();
     }
-
-    public override int SelectAction() {
-      Debug.Assert(Actions.Any());
+    public int SelectAction(Random random, IEnumerable<IPolicyActionInfo> actionInfos) {
+      Debug.Assert(actionInfos.Any());
       if (random.NextDouble() > eps) {
         // select best
-        var bestQ = double.NegativeInfinity;
+        var myActionInfos = actionInfos.OfType<DefaultPolicyActionInfo>();
         int bestAction = -1;
-        foreach (var a in Actions) {
-          if (tries[a] == 0) return a;
-          var q = sumReward[a] / tries[a];
-          if (bestQ < q) {
+        double bestQ = double.NegativeInfinity;
+        int aIdx = -1;
+        foreach (var aInfo in myActionInfos) {
+
+          aIdx++;
+          if (aInfo.Disabled) continue;
+          if (aInfo.Tries == 0) return aIdx;
+
+
+          var avgReward = aInfo.SumReward / aInfo.Tries;         
+          //var q = avgReward;
+          var q = aInfo.MaxReward;
+          if (q > bestQ) {
             bestQ = q;
-            bestAction = a;
+            bestAction = aIdx;
           }
         }
@@ -41,38 +42,13 @@
       } else {
         // select random
-        return randomPolicy.SelectAction();
+        return randomPolicy.SelectAction(random, actionInfos);
       }
     }
-    public override void UpdateReward(int action, double reward) {
-      Debug.Assert(Actions.Contains(action));
 
-      randomPolicy.UpdateReward(action, reward); // does nothing
-      tries[action]++;
-      sumReward[action] += reward;
+    public IPolicyActionInfo CreateActionInfo() {
+      return new DefaultPolicyActionInfo();
     }
 
-    public override void DisableAction(int action) {
-      base.DisableAction(action);
-      randomPolicy.DisableAction(action);
-      sumReward[action] = 0;
-      tries[action] = -1;
-    }
 
-    public override void Reset() {
-      base.Reset();
-      randomPolicy.Reset();
-      Array.Clear(tries, 0, tries.Length);
-      Array.Clear(sumReward, 0, sumReward.Length);
-    }
-    public override void PrintStats() {
-      for (int i = 0; i < sumReward.Length; i++) {
-        if (tries[i] >= 0) {
-          Console.Write(" {0,5:F2} {1}", sumReward[i] / tries[i], tries[i]);
-        } else {
-          Console.Write("-", "");
-        }
-      }
-      Console.WriteLine();
-    }
     public override string ToString() {
       return string.Format("EpsGreedyPolicy({0:F2})", eps);
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/GaussianThompsonSamplingPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/GaussianThompsonSamplingPolicy.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/GaussianThompsonSamplingPolicy.cs	(revision 11732)
@@ -1,3 +1,4 @@
 ﻿using System;
+using System.Collections.Generic;
 using System.Diagnostics;
 using System.Linq;
@@ -5,10 +6,6 @@
 
 namespace HeuristicLab.Algorithms.Bandits {
-  
-  public class GaussianThompsonSamplingPolicy : BanditPolicy {
-    private readonly Random random;
-    private readonly double[] sampleMean;
-    private readonly double[] sampleM2;
-    private readonly int[] tries;
+
+  public class GaussianThompsonSamplingPolicy : IPolicy {
     private bool compatibility;
 
@@ -21,25 +18,27 @@
 
 
-    public GaussianThompsonSamplingPolicy(Random random, int numActions, bool compatibility = false)
-      : base(numActions) {
-      this.random = random;
-      this.sampleMean = new double[numActions];
-      this.sampleM2 = new double[numActions];
-      this.tries = new int[numActions];
+    public GaussianThompsonSamplingPolicy(bool compatibility = false) {
       this.compatibility = compatibility;
     }
 
+    public int SelectAction(Random random, IEnumerable<IPolicyActionInfo> actionInfos) {
+      var myActionInfos = actionInfos.OfType<MeanAndVariancePolicyActionInfo>();
+      int bestAction = -1;
+      double bestQ = double.NegativeInfinity;
 
-    public override int SelectAction() {
-      Debug.Assert(Actions.Any());
-      var maxTheta = double.NegativeInfinity;
-      int bestAction = -1;
-      foreach (var a in Actions) {
-        if(tries[a] == -1) continue; // skip disabled actions
+      int aIdx = -1;
+      foreach (var aInfo in myActionInfos) {
+        aIdx++;
+        if (aInfo.Disabled) continue;
+
+        var tries = aInfo.Tries;
+        var sampleMean = aInfo.AvgReward;
+        var sampleVariance = aInfo.RewardVariance;
+
         double theta;
         if (compatibility) {
-          if (tries[a] < 2) return a;
-          var mu = sampleMean[a];
-          var variance = sampleM2[a] / tries[a];
+          if (tries < 2) return aIdx;
+          var mu = sampleMean;
+          var variance = sampleVariance;
           var stdDev = Math.Sqrt(variance);
           theta = Rand.RandNormal(random) * stdDev + mu;
@@ -48,6 +47,6 @@
 
           // see Murphy 2007: Conjugate Bayesian analysis of the Gaussian distribution (http://www.cs.ubc.ca/~murphyk/Papers/bayesGauss.pdf)
-          var posteriorVariance = 1.0 / (tries[a] / rewardVariance + 1.0 / priorVariance);
-          var posteriorMean = posteriorVariance * (priorMean / priorVariance + tries[a] * sampleMean[a] / rewardVariance);
+          var posteriorVariance = 1.0 / (tries / rewardVariance + 1.0 / priorVariance);
+          var posteriorMean = posteriorVariance * (priorMean / priorVariance + tries * sampleMean / rewardVariance);
 
           // sample a mean from the posterior 
@@ -56,45 +55,27 @@
           // theta already represents the expected reward value => nothing else to do
         }
-        if (theta > maxTheta) {
-          maxTheta = theta;
-          bestAction = a;
+
+        if (theta > bestQ) {
+          bestQ = theta;
+          bestAction = aIdx;
         }
       }
-      Debug.Assert(Actions.Contains(bestAction));
+      Debug.Assert(bestAction > -1);
       return bestAction;
     }
 
-    public override void UpdateReward(int action, double reward) {
-      Debug.Assert(Actions.Contains(action));
-      tries[action]++;
-      var delta = reward - sampleMean[action];
-      sampleMean[action] += delta / tries[action];
-      sampleM2[action] += sampleM2[action] + delta * (reward - sampleMean[action]);
+    public IPolicyActionInfo CreateActionInfo() {
+      return new MeanAndVariancePolicyActionInfo();
     }
 
-    public override void DisableAction(int action) {
-      base.DisableAction(action);
-      sampleMean[action] = 0;
-      sampleM2[action] = 0;
-      tries[action] = -1;
-    }
 
-    public override void Reset() {
-      base.Reset();
-      Array.Clear(sampleMean, 0, sampleMean.Length);
-      Array.Clear(sampleM2, 0, sampleM2.Length);
-      Array.Clear(tries, 0, tries.Length);
-    }
+    //public override void UpdateReward(int action, double reward) {
+    //  Debug.Assert(Actions.Contains(action));
+    //  tries[action]++;
+    //  var delta = reward - sampleMean[action];
+    //  sampleMean[action] += delta / tries[action];
+    //  sampleM2[action] += sampleM2[action] + delta * (reward - sampleMean[action]);
+    //}
 
-    public override void PrintStats() {
-      for (int i = 0; i < sampleMean.Length; i++) {
-        if (tries[i] >= 0) {
-          Console.Write(" {0,5:F2} {1}", sampleMean[i] / tries[i], tries[i]);
-        } else {
-          Console.Write("{0,5}", "");
-        }
-      }
-      Console.WriteLine();
-    }
     public override string ToString() {
       return "GaussianThompsonSamplingPolicy";
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/GenericThompsonSamplingPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/GenericThompsonSamplingPolicy.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/GenericThompsonSamplingPolicy.cs	(revision 11732)
@@ -8,47 +8,32 @@
 
 namespace HeuristicLab.Algorithms.Bandits {
-  public class GenericThompsonSamplingPolicy : BanditPolicy {
-    private readonly Random random;
+  public class GenericThompsonSamplingPolicy : IPolicy {
     private readonly IModel model;
 
-    public GenericThompsonSamplingPolicy(Random random, int numActions, IModel model)
-      : base(numActions) {
-      this.random = random;
+    public GenericThompsonSamplingPolicy(IModel model) {
       this.model = model;
     }
 
-    public override int SelectAction() {
-      Debug.Assert(Actions.Any());
-      var maxR = double.NegativeInfinity;
+    public int SelectAction(Random random, IEnumerable<IPolicyActionInfo> actionInfos) {
+      var myActionInfos = actionInfos.OfType<ModelPolicyActionInfo>();
       int bestAction = -1;
-      var expRewards = model.SampleExpectedRewards(random);
-      foreach (var a in Actions) {
-        var r = expRewards[a];
-        if (r > maxR) {
-          maxR = r;
-          bestAction = a;
+      double bestQ = double.NegativeInfinity;
+      var aIdx = -1;
+      foreach (var aInfo in myActionInfos) {
+        aIdx++;
+        if (aInfo.Disabled) continue;
+        //if (aInfo.Tries == 0) return aIdx;
+        var q = aInfo.SampleExpectedReward(random);
+        if (q > bestQ) {
+          bestQ = q;
+          bestAction = aIdx;
         }
       }
+      Debug.Assert(bestAction > -1);
       return bestAction;
     }
 
-    public override void UpdateReward(int action, double reward) {
-      Debug.Assert(Actions.Contains(action));
-
-      model.Update(action, reward);
-    }
-
-    public override void DisableAction(int action) {
-      base.DisableAction(action);
-      model.Disable(action);
-    }
-
-    public override void Reset() {
-      base.Reset();
-      model.Reset();
-    }
-
-    public override void PrintStats() {
-      model.PrintStats();
+    public IPolicyActionInfo CreateActionInfo() {
+      return new ModelPolicyActionInfo((IModel)model.Clone());
     }
 
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/MeanAndVariancePolicyActionInfo.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/MeanAndVariancePolicyActionInfo.cs	(revision 11732)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/MeanAndVariancePolicyActionInfo.cs	(revision 11732)
@@ -0,0 +1,36 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  public class MeanAndVariancePolicyActionInfo : IPolicyActionInfo {
+    private bool disabled;
+    public bool Disabled { get { return disabled; } }
+    private OnlineMeanAndVarianceEstimator estimator = new OnlineMeanAndVarianceEstimator();
+    public int Tries { get { return estimator.N; } }
+    public double SumReward { get { return estimator.Sum; } }
+    public double AvgReward { get { return estimator.Avg; } }
+    public double RewardVariance { get { return estimator.Variance; } }
+
+    public void UpdateReward(double reward) {
+      Debug.Assert(!Disabled);
+      estimator.UpdateReward(reward);
+    }
+
+    public void Disable() {
+      disabled = true;
+    }
+
+    public void Reset() {
+      disabled = false;
+      estimator.Reset();
+    }
+
+    public void PrintStats() {
+      Console.WriteLine("avg reward {0,5:F2} disabled {1}", AvgReward, Disabled);
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/ModelPolicyActionInfo.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/ModelPolicyActionInfo.cs	(revision 11732)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/ModelPolicyActionInfo.cs	(revision 11732)
@@ -0,0 +1,41 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  // uses a statistical model to sample and update posterior distribution p(Reward | Data)
+  public class ModelPolicyActionInfo : IPolicyActionInfo {
+    private readonly IModel model;
+    public bool Disabled { get { return Tries == -1; } }
+
+    public int Tries { get; private set; }
+    public ModelPolicyActionInfo(IModel model) {
+      this.model = model;
+    }
+
+    public void UpdateReward(double reward) {
+      Debug.Assert(!Disabled);
+      model.Update(reward);
+    }
+
+    public double SampleExpectedReward(Random random) {
+      return model.SampleExpectedReward(random);
+    }
+
+    public void Disable() {
+      this.Tries = -1;
+    }
+
+    public void Reset() {
+      Tries = 0;
+      model.Reset();
+    }
+
+    public void PrintStats() {
+      model.PrintStats();
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/RandomPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/RandomPolicy.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/RandomPolicy.cs	(revision 11732)
@@ -8,25 +8,20 @@
 
 namespace HeuristicLab.Algorithms.Bandits {
-  public class RandomPolicy : BanditPolicy {
-    private readonly Random random;
+  public class RandomPolicy : IPolicy {
 
-    public RandomPolicy(Random random, int numActions)
-      : base(numActions) {
-      this.random = random;
-    }
-
-    public override int SelectAction() {
-      Debug.Assert(Actions.Any());
-      return Actions.SelectRandom(random);
-    }
-    public override void UpdateReward(int action, double reward) {
-      // do nothing
-    }
-    public override void PrintStats() {
-      Console.WriteLine("Random");
-    }
     public override string ToString() {
       return "RandomPolicy";
     }
+
+    public int SelectAction(Random random, IEnumerable<IPolicyActionInfo> actionInfos) {
+      return actionInfos
+        .Select((a, i) => Tuple.Create(a, i))
+        .Where(p => !p.Item1.Disabled)
+        .SelectRandom(random).Item2;
+    }
+
+    public IPolicyActionInfo CreateActionInfo() {
+      return new EmptyPolicyActionInfo();
+    }
   }
 }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCB1Policy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCB1Policy.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCB1Policy.cs	(revision 11732)
@@ -7,20 +7,15 @@
 
 namespace HeuristicLab.Algorithms.Bandits {
-  public class UCB1Policy : BanditPolicy {
-    private readonly int[] tries;
-    private readonly double[] sumReward;
-    private int totalTries = 0;
-    public UCB1Policy(int numActions)
-      : base(numActions) {
-      this.tries = new int[numActions];
-      this.sumReward = new double[numActions];
-    }
-
-    public override int SelectAction() {
+  public class UCB1Policy : IPolicy {
+    public int SelectAction(Random random, IEnumerable<IPolicyActionInfo> actionInfos) {
+      var myActionInfos = actionInfos.OfType<DefaultPolicyActionInfo>().ToArray(); // TODO: performance
       int bestAction = -1;
       double bestQ = double.NegativeInfinity;
-      foreach (var a in Actions) {
-        if (tries[a] == 0) return a;
-        var q = sumReward[a] / tries[a] + Math.Sqrt((2 * Math.Log(totalTries)) / tries[a]);
+      int totalTries = myActionInfos.Where(a => !a.Disabled).Sum(a => a.Tries);
+
+      for (int a = 0; a < myActionInfos.Length; a++) {
+        if (myActionInfos[a].Disabled) continue;
+        if (myActionInfos[a].Tries == 0) return a;
+        var q = myActionInfos[a].SumReward / myActionInfos[a].Tries + Math.Sqrt((2 * Math.Log(totalTries)) / myActionInfos[a].Tries);
         if (q > bestQ) {
           bestQ = q;
@@ -28,35 +23,10 @@
         }
       }
+      Debug.Assert(bestAction > -1);
       return bestAction;
     }
-    public override void UpdateReward(int action, double reward) {
-      Debug.Assert(Actions.Contains(action));
-      totalTries++;
-      tries[action]++;
-      sumReward[action] += reward;
-    }
 
-    public override void DisableAction(int action) {
-      base.DisableAction(action);
-      totalTries -= tries[action];
-      tries[action] = -1;
-      sumReward[action] = 0;
-    }
-
-    public override void Reset() {
-      base.Reset();
-      totalTries = 0;
-      Array.Clear(tries, 0, tries.Length);
-      Array.Clear(sumReward, 0, sumReward.Length);
-    }
-    public override void PrintStats() {
-      for (int i = 0; i < sumReward.Length; i++) {
-        if (tries[i] >= 0) {
-          Console.Write("{0,5:F2}", sumReward[i] / tries[i]);
-        } else {
-          Console.Write("{0,5}", "");
-        }
-      }
-      Console.WriteLine();
+    public IPolicyActionInfo CreateActionInfo() {
+      return new DefaultPolicyActionInfo();
     }
     public override string ToString() {
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCB1TunedPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCB1TunedPolicy.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCB1TunedPolicy.cs	(revision 11732)
@@ -7,29 +7,21 @@
 
 namespace HeuristicLab.Algorithms.Bandits {
-  public class UCB1TunedPolicy : BanditPolicy {
-    private readonly int[] tries;
-    private readonly double[] sumReward;
-    private readonly double[] sumSqrReward;
-    private int totalTries = 0;
-    public UCB1TunedPolicy(int numActions)
-      : base(numActions) {
-      this.tries = new int[numActions];
-      this.sumReward = new double[numActions];
-      this.sumSqrReward = new double[numActions];
-    }
+  public class UCB1TunedPolicy : IPolicy {
 
-    private double V(int arm) {
-      var s = tries[arm];
-      return sumSqrReward[arm] / s - Math.Pow(sumReward[arm] / s, 2) + Math.Sqrt(2 * Math.Log(totalTries) / s);
-    }
-
-
-    public override int SelectAction() {
-      Debug.Assert(Actions.Any());
+    public int SelectAction(Random random, IEnumerable<IPolicyActionInfo> actionInfos) {
+      var myActionInfos = actionInfos.OfType<MeanAndVariancePolicyActionInfo>().ToArray(); // TODO: performance
       int bestAction = -1;
       double bestQ = double.NegativeInfinity;
-      foreach (var a in Actions) {
-        if (tries[a] == 0) return a;
-        var q = sumReward[a] / tries[a] + Math.Sqrt((Math.Log(totalTries) / tries[a]) * Math.Min(1.0 / 4, V(a))); // 1/4 is upper bound of bernoulli distributed variable
+      int totalTries = myActionInfos.Where(a => !a.Disabled).Sum(a => a.Tries);
+
+      for (int a = 0; a < myActionInfos.Length; a++) {
+        if (myActionInfos[a].Disabled) continue;
+        if (myActionInfos[a].Tries == 0) return a;
+
+        var sumReward = myActionInfos[a].SumReward;
+        var tries = myActionInfos[a].Tries;
+
+        var avgReward = sumReward / tries;
+        var q = avgReward + Math.Sqrt((Math.Log(totalTries) / tries) * Math.Min(1.0 / 4, V(myActionInfos[a], totalTries))); // 1/4 is upper bound of bernoulli distributed variable
         if (q > bestQ) {
           bestQ = q;
@@ -37,39 +29,17 @@
         }
       }
+      Debug.Assert(bestAction > -1);
       return bestAction;
     }
-    public override void UpdateReward(int action, double reward) {
-      Debug.Assert(Actions.Contains(action));
-      totalTries++;
-      tries[action]++;
-      sumReward[action] += reward;
-      sumSqrReward[action] += reward * reward;
+
+    public IPolicyActionInfo CreateActionInfo() {
+      return new MeanAndVariancePolicyActionInfo();
     }
 
-    public override void DisableAction(int action) {
-      base.DisableAction(action);
-      totalTries -= tries[action];
-      tries[action] = -1;
-      sumReward[action] = 0;
-      sumSqrReward[action] = 0;
+    private double V(MeanAndVariancePolicyActionInfo actionInfo, int totalTries) {
+      var s = actionInfo.Tries;
+      return actionInfo.RewardVariance + Math.Sqrt(2 * Math.Log(totalTries) / s);
     }
 
-    public override void Reset() {
-      base.Reset();
-      totalTries = 0;
-      Array.Clear(tries, 0, tries.Length);
-      Array.Clear(sumReward, 0, sumReward.Length);
-      Array.Clear(sumSqrReward, 0, sumSqrReward.Length);
-    }
-    public override void PrintStats() {
-      for (int i = 0; i < sumReward.Length; i++) {
-        if (tries[i] >= 0) {
-          Console.Write("{0,5:F2}", sumReward[i] / tries[i]);
-        } else {
-          Console.Write("{0,5}", "");
-        }
-      }
-      Console.WriteLine();
-    }
     public override string ToString() {
       return "UCB1TunedPolicy";
